// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*! 
 * @file Twist.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _GEOMETRY_MSGS_TWIST_HPP_
#define _GEOMETRY_MSGS_TWIST_HPP_


#include <ros2/topic.hpp>

#include "../geometry_msgs/Vector3.hpp"


namespace geometry_msgs {

class Twist : public ros2::Topic<Twist>
{
public:
  geometry_msgs::Vector3 linear;
  geometry_msgs::Vector3 angular;

  Twist():
    Topic("geometry_msgs::msg::dds_::Twist_", "Twist"),
    linear(),
    angular()
  { 
  }


  bool serialize(void* msg_buf, const Twist* topic)
  {
    ucdrBuffer* writer = (ucdrBuffer*)msg_buf;
    (void) linear.serialize(writer, &topic->linear);
    (void) angular.serialize(writer, &topic->angular);

    return !writer->error;
  }

  bool deserialize(void* msg_buf, Twist* topic)
  {
    ucdrBuffer* reader = (ucdrBuffer*)msg_buf;
    (void) linear.deserialize(reader, &topic->linear);
    (void) angular.deserialize(reader, &topic->angular);

    return !reader->error;
  }

  uint32_t size_of_topic(const Twist* topic, uint32_t size)
  {
    uint32_t previousSize = size;
    size += linear.size_of_topic(&topic->linear, size);
    size += angular.size_of_topic(&topic->angular, size);
    
    return size - previousSize;
  }



};

} // namespace geometry_msgs


#endif // _GEOMETRY_MSGS_TWIST_HPP_
