// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*! 
 * @file TwistWithCovariance.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _GEOMETRY_MSGS_TWIST_WITH_CONVARIANCE_HPP_
#define _GEOMETRY_MSGS_TWIST_WITH_CONVARIANCE_HPP_


#include <ros2/topic.hpp>


#include "../geometry_msgs/Twist.hpp"

namespace geometry_msgs {

class TwistWithCovariance : public ros2::Topic<TwistWithCovariance>
{
public:
  geometry_msgs::Twist twist;
  double covariance[36];

  TwistWithCovariance():
    Topic("geometry_msgs::msg::dds_::TwistWithCovariance_", "TwistWithCovariance"),
    twist()
  { 
    memset(covariance, 0, sizeof(covariance));
  }

  bool serialize(void* msg_buf, const TwistWithCovariance* topic)
  {
    ucdrBuffer* writer = (ucdrBuffer*)msg_buf;
    (void) twist.serialize(writer, &topic->twist);
    (void) ucdr_serialize_array_double(writer, topic->covariance, 36);

    return !writer->error;
  }

  bool deserialize(void* msg_buf, TwistWithCovariance* topic)
  {
    ucdrBuffer* reader = (ucdrBuffer*)msg_buf;
    (void) twist.deserialize(reader, &topic->twist);
    (void) ucdr_deserialize_array_double(reader, topic->covariance, 36);

    return !reader->error;
  }

  uint32_t size_of_topic(const TwistWithCovariance* topic, uint32_t size)
  {
    uint32_t previousSize = size;
    size += twist.size_of_topic(&topic->twist, size);
    size += ucdr_alignment(size, 8) + ((36) * 8);
    
    return size - previousSize;
  }



};

} // namespace geometry_msgs


#endif // _GEOMETRY_MSGS_TWIST_WITH_CONVARIANCE_HPP_
